/*
 *  VST_ROTATION                                (C) Digital Design 1990
 *
 *  SET CHARACTER BASELINE VEKTOR
 *
 *  Die Grundlinie der Zeichen kann mit dieser Funktion gedreht werden.
 *  Somit kann Text kreuz und quer auf dem Bildschirm oder anderen
 *  Gerten ausgegeben werden. Der Winkel wird in 1/10 Grad gem
 *  folgender Spezifikation angegeben:
 *              900
 *               .
 *               .
 *      1800............0
 *               .
 *               .
 *              2700
 *  Diese Funktion ist nicht auf jedem Gert verfgbar. Die Funktionen
 *  V_OPNWK..\CONTROL\V_OPNWK.C und V_OPNVWK..\CONTROL\V_OPNVWK.C teilen dies in work_ou[36] mit.
 */
#include <gemdefs.h>

int vst_rotation( int handle, int angle )
{
  intin[0] = angle; /* Winkel der Zeichengrundlinie (0-3600)            */

  VDI( 13, 0, 1, handle );

  return intout[0]; /* = set_baseline: Ausgewhlter Winkel              */
}

