/*
 *  V_UPDWK                                     (C) Digital Design 1991
 *
 *  UPDATE WORKSTATION
 *
 *  "UPDATE WORKSTATION" wird bentigt, um einem Ein-/Ausgabegert mit-
 *  zuteilen, alle gepufferten Graphikkommandos auszufhren. Auf einem
 *  Bildschirm wird diese Funktion nicht bentigt, da die Graphikkoman-
 *  dos hier umgehend ausgefhrt werden.
 *  So speichern beispielsweise Druckertreiber die Kommandos in einem
 *  Puffer (wird beim Druckertreiber auch Display-List genannt). Die
 *  Ausgabe ber diese Gerte erfolgt erst nach Aufruf der "UPDATE
 *  WORKSTATION"-Funktion. Ist der Buffer fr das Ausgabegert geleert,
 *  kehrt die "UPDATE WORKSTATION"-Funktion zurck. Zu beachten ist
 *  hierbei, da bei einem Drucker kein Seitenvorschub gegeben wird.
 *
 *  Zustzliche Funktion fr Druckertreiber: Statt der aktuellen Seite
 *  kann ein eigener Buffer auf dem Drucker ausgegeben werden:
 *
 *      *(void **)intin = [Anfangsadresse des Buffers];
 *      VDI( 4, 1, 1, handle ); // contrl[1] = 1: Buffer nicht lschen
 *
 *  Zustzliche Funktion fr den ATARI-Page-Printer (SLM 804):
 *  In intout[0] wird der Status des Druckers zurckgeliefert:
 *
 *      0 = NO ERROR
 *      2 = PRINTER NOT READY
 *      3 = TONER EMPTY
 *      4 = WARM UP
 *      5 = PAPER EMPTY
 *      6 = DRUM EMPTY
 *      7 = INPUT JAM
 *      8 = THROUGH JAM
 *      9 = OUTPUT JAM
 *     10 = COVER OPEN
 *     11 = FUSER MALFUNCTION
 *     12 = IMAGER MALFUNCTION
 *     13 = MOTOR MALFUNCTION
 *     14 = VIDEO MALFUNCTION
 *     16 = SYSTEM TIMEOUT
 */
#include <gemdefs.h>

void v_updwk( int handle )
{
  VDI( 4, 0, 0, handle );
}
